---
title: ConstrainDouble
slug: Web/API/ConstrainDouble
tags:
  - API
  - Constraints
  - Dictionary
  - Interface
  - Media
  - Media Capture and Streams API
  - Media Stream API
  - Reference
  - WebRTC
---
<div>{{APIRef("Media Capture and Streams")}}</div>

<p>The <strong><code>ConstrainDouble</code></strong> type is used to specify a constraint for a property whose value is a double-precision floating-point number. It extends the {{domxref("DoubleRange")}} dictionary (which provides the ability to specify a permitted range of property values) to also support an exact value and/or an ideal value the property should take on. Additionally, you can specify the property's value as a simple floating-point value, in which case the user agent does its best to match the value once all other more stringent constraints are met.</p>

<h2 id="Properties">Properties</h2>

<p><em>If the value of a <code>ConstrainDouble</code> is an object rather than a number, it may have the properties below in addition the properties it inherits from {{domxref("DoubleRange")}}.</em></p>

<dl>
 <dt><code>exact</code></dt>
 <dd>A double-precision floating-point number specifying a specific, required, value the property must have to be considered acceptable.</dd>
 <dt><code>ideal</code></dt>
 <dd>A double-precision floating-point number specifying a value the property would ideally have, but which can be considered optional if necessary to find a match.</dd>
</dl>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Media Capture', '#dom-constraindouble', 'ConstrainDouble')}}</td>
   <td>{{Spec2('Media Capture')}}</td>
   <td>Initial definition</td>
  </tr>
 </tbody>
</table>

<div class="note">
<p>Technically, <code>ConstrainDouble</code> is actually based on an intermediary dictionary named <code>ConstrainDoubleRange</code>, which adds <code>exact</code> and <code>ideal</code> to {{domxref("DoubleRange")}}, with <code>ConstrainDouble</code> being a type that can be either a long integer or a <code>DoubleRange</code>. However, for the sake of documentation clarity, the intermediate type (present only because of quirks in {{Glossary("WebIDL")}} syntax) is ignored here.</p>
</div>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.ConstrainDouble")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/Media_Streams_API">Media Capture and Streams API</a></li>
 <li><a href="/en-US/docs/Web/API/Media_Streams_API/Constraints">Capabilities, constraints, and settings</a></li>
 <li>{{domxref("DoubleRange")}}</li>
 <li>{{domxref("MediaTrackConstraints")}}</li>
 <li>{{domxref("MediaTrackCapabilities")}}</li>
 <li>{{domxref("MediaTrackSupportedConstraints")}}</li>
</ul>
